| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | List of all members
nkAstraeus::System Class Referencefinal

The main entry point for nkAstraeus engine. More...

Inheritance diagram for nkAstraeus::System:

## Public Member Functions
| System () noexcept
virtual | ~System ()
GraphicsEngine * | getGraphicsEngine () const
ScriptsEngine * | getScriptsEngine () const
ContentLoader * | getContentLoader () const
ProjectLoader * | getProjectLoader () const
PbsEnvironmentMapFilter * | getPbsEnvironmentMapFilter () const
EnvironmentRenderer * | getEnvironmentRenderer () const
ComplexEffectManager * | getComplexEffectManager () const
EffectManager * | getEffectManager () const
LogManager * | getLogManager () const
MaterialManager * | getMaterialManager () const
bool | initialize (const Configuration &config=Configuration())
void | shutdown ()

## Detailed Description

The main entry point for nkAstraeus engine.

It allows to drive the initialization and shutdown of the engine. This will initialize all the sub component at once. If need be, all sub components can be initialized individually. This can be useful, for instance, to initialize the scripting environment and access wrapping alone.

## Constructor & Destructor Documentation

## ◆ System()

nkAstraeus::System::System | ( |  | ) |
| noexcept

Default constructor.

## ◆ ~System()

virtual nkAstraeus::System::~System | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getGraphicsEngine()

GraphicsEngine* nkAstraeus::System::getGraphicsEngine | ( |  | ) | const

Returns
  The graphics engine associated with the system instance.

## ◆ getScriptsEngine()

ScriptsEngine* nkAstraeus::System::getScriptsEngine | ( |  | ) | const

Returns
  The scripts engine associated with the system instance.

## ◆ getContentLoader()

ContentLoader* nkAstraeus::System::getContentLoader | ( |  | ) | const

Returns
  The content loader associated with the system instance.

## ◆ getProjectLoader()

ProjectLoader* nkAstraeus::System::getProjectLoader | ( |  | ) | const

Returns
  The project loader associated with the system instance.

## ◆ getPbsEnvironmentMapFilter()

PbsEnvironmentMapFilter* nkAstraeus::System::getPbsEnvironmentMapFilter | ( |  | ) | const

Returns
  The physically based shading environment map filter associated with the system instance.

## ◆ getEnvironmentRenderer()

EnvironmentRenderer* nkAstraeus::System::getEnvironmentRenderer | ( |  | ) | const

Returns
  The environment renderer associated with the system instance.

## ◆ getComplexEffectManager()

ComplexEffectManager* nkAstraeus::System::getComplexEffectManager | ( |  | ) | const

Returns
  The complex effect manager associated with the system instance.

## ◆ getEffectManager()

EffectManager* nkAstraeus::System::getEffectManager | ( |  | ) | const

Returns
  The effect manager associated with the system instance.

## ◆ getLogManager()

LogManager* nkAstraeus::System::getLogManager | ( |  | ) | const

Returns
  The log manager associated with the system instance.

## ◆ getMaterialManager()

MaterialManager* nkAstraeus::System::getMaterialManager | ( |  | ) | const

Returns
  The material manager associated with the system instance.

## ◆ initialize()

bool nkAstraeus::System::initialize | ( | const Configuration & | config = `Configuration()` | ) |

Initializes the whole nkAstraeus component. This will ensure all sub components of the engine are thoroughly initialized.

Parameters

  config | The configuration to use when initializing the system.

Returns
  Whether the initialization went well (true) or not (false).

Remarks
  If the initialization process fails, it will be necessary to check the log and fix the problem, as the engine will be unusable.

## ◆ shutdown()

void nkAstraeus::System::shutdown | ( |  | ) |

Shuts down the engine and clear all memory of the component, and its sub parts.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsAstraeus/System.h